commit abdcc863069315f92c03f7cf86e5a55be12a5932
Author: freddy77 <freddy77>
Date:   Fri Jul 2 09:30:49 2010 +0000

    add desc_get_dbc and reuse it

diff --git a/ChangeLog b/ChangeLog
index 0d1c24a..b656f9e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Jul  2 11:30:40 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/descriptor.c src/odbc/error.c:
+	- add desc_get_dbc and reuse it
+
 Fri Jul  2 11:01:08 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/stats.c:
 	- correct wrong assumption about statistics functions
@@ -2544,4 +2548,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3047 2010/07/02 09:01:22 freddy77 Exp $
+$Id: ChangeLog,v 1.3048 2010/07/02 09:30:49 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index cfac365..c2adfcf 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.120 2010/06/28 20:24:49 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.121 2010/07/02 09:30:49 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4 && !defined(__MINGW32__)
 #pragma GCC visibility push(hidden)
@@ -499,6 +499,7 @@ SQLRETURN desc_free(TDS_DESC * desc);
 SQLRETURN desc_alloc_records(TDS_DESC * desc, unsigned count);
 SQLRETURN desc_copy(TDS_DESC * dest, TDS_DESC * src);
 SQLRETURN desc_free_records(TDS_DESC * desc);
+TDS_DBC *desc_get_dbc(TDS_DESC *desc);
 
 /*
  * odbc.c
diff --git a/src/odbc/descriptor.c b/src/odbc/descriptor.c
index 1eae216..feecd70 100644
--- a/src/odbc/descriptor.c
+++ b/src/odbc/descriptor.c
@@ -213,3 +213,13 @@ desc_free(TDS_DESC * desc)
 	}
 	return SQL_SUCCESS;
 }
+
+TDS_DBC *
+desc_get_dbc(TDS_DESC *desc)
+{
+	if (IS_HSTMT(desc->parent))
+		return ((TDS_STMT *) desc->parent)->dbc;
+
+	return (TDS_DBC *) desc->parent;
+}
+
diff --git a/src/odbc/error.c b/src/odbc/error.c
index e5eaa09..10ae77f 100644
--- a/src/odbc/error.c
+++ b/src/odbc/error.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: error.c,v 1.58 2009/12/16 13:06:30 freddy77 Exp $");
+TDS_RCSID(var, "$Id: error.c,v 1.59 2010/07/02 09:30:49 freddy77 Exp $");
 
 static void odbc_errs_pop(struct _sql_errors *errs);
 static const char *odbc_get_msg(const char *sqlstate);
@@ -512,7 +512,6 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	static const char msgprefix[] = "[FreeTDS][SQL Server]";
 
 	SQLINTEGER odbc_ver = SQL_OV_ODBC2;
-	SQLHANDLE parent;
 
 	if (numRecord <= 0 || cbErrorMsgMax < 0)
 		return SQL_ERROR;
@@ -534,11 +533,7 @@ _SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 		odbc_ver = ((TDS_ENV *) handle)->attr.odbc_version;
 		break;
 	case SQL_HANDLE_DESC:
-		parent = ((TDS_DESC *) handle)->parent;
-		if (((TDS_CHK *) parent)->htype == SQL_HANDLE_DBC)
-			odbc_ver = ((TDS_DBC *) parent)->env->attr.odbc_version;
-		else
-			odbc_ver = ((TDS_STMT *) parent)->dbc->env->attr.odbc_version;
+		odbc_ver = desc_get_dbc((TDS_DESC *) handle)->env->attr.odbc_version;
 		break;
 	default:
 		return SQL_INVALID_HANDLE;
@@ -637,7 +632,6 @@ SQLGetDiagField(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 	TDS_STMT *stmt = NULL;
 	TDS_DBC *dbc = NULL;
 	TDS_ENV *env = NULL;
-	SQLHANDLE parent;
 	char tmp[16];
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagField(%d, %p, %d, %d, %p, %d, %p)\n", 
@@ -666,13 +660,7 @@ SQLGetDiagField(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord,
 		break;
 
 	case SQL_HANDLE_DESC:
-		parent = ((TDS_DESC *) handle)->parent;
-		if (((TDS_CHK *) parent)->htype == SQL_HANDLE_DBC) {
-			dbc = (TDS_DBC *) parent;
-		} else {
-			stmt = (TDS_STMT *) parent;
-			dbc = stmt->dbc;
-		}
+		dbc = desc_get_dbc((TDS_DESC *) handle);
 		env = dbc->env;
 		break;
 

